#include <bits/stdc++.h>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int ui32;
const long long INFLL = 1e18;

using namespace std;

const int MAXN = 1000;
const int MAXT = 49;

char f[MAXN][MAXN];
string ans;

void dec(int &x) {
    --x;
    x = max(x, 30);
}

bool getPath(int newX, int newY, int &curX, int &curY, int &curT, bool toBeDown) {
    int wasX = curX, wasY = curY, wasT = curT;

    string tmp = "";
    while (curY < newY) {
        tmp += "E";
        ++curY;
        if (toBeDown) {
            ++curT;
        } else {
            dec(curT);
        }
        if (toBeDown && f[curX][curY] == '.' || curT > MAXT) {
            curX = wasX, curY = wasY, curT = wasT;
            return false;
        }
    }
    while (curY > newY) {
        tmp += "W";
        --curY;
        if (toBeDown) {
            ++curT;
        } else {
            dec(curT);
        }
        if (toBeDown && f[curX][curY] == '.' || curT > MAXT) {
            curX = wasX, curY = wasY, curT = wasT;
            return false;
        }
    }
    while (curX < newX) {
        tmp += "S";
        ++curX;
        if (toBeDown) {
            ++curT;
        } else {
            dec(curT);
        }
        if (toBeDown && f[curX][curY] == '.' || curT > MAXT) {
            curX = wasX, curY = wasY, curT = wasT;
            return false;
        }
    }
    ans += tmp;
    return true;
}

int dist(int x1, int y1, int x2, int y2) {
    return abs(x1 - x2) + abs(y1 - y2);
}

bool cmp(const pair<int, int> &lhs, const pair<int, int> &rhs) {
    if (lhs.first != rhs.first) {
        return lhs.first < rhs.first;
    } else if (lhs.first & 1) {
        return lhs.second > rhs.second;
    } else {
        return lhs.second < rhs.second;
    }
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    vector<pair<int, int> > points;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j];
            if (f[i][j] == '*') {
                points.push_back({ i, j });
            }
        }
    }
    sort(points.begin(), points.end(), cmp);

    int curT = 30;
    int curX = 0, curY = 0;
    bool onDown = false;

    for (auto pt : points) {
        int i = pt.first;
        int j = pt.second;

        if (onDown && getPath(i, j, curX, curY, curT, true)) {

        } else if (onDown) {
            ans += "U";
            getPath(i, j, curX, curY, curT, false);
            ans += "D";
            onDown = true;
        } else {
            getPath(i, j, curX, curY, curT, false);
            ans += "D";
            onDown = true;
        }
    }

    cout << ans << "\n";
    return 0;
}
